From 61a00e690d9a364289c66d41d491a0d8ff48c7dd Mon Sep 17 00:00:00 2001
From: Govind Singh <govinds@codeaurora.org>
Date: Mon, 4 May 2020 14:12:26 +0530
Subject: [PATCH 036/124] ath11k: Use remoteproc only for non MHI targets

QCA6x90 uses mhi based fw loading and does not use
remoteproc. Use remoteproc only for non MHI targets.

Change-Id: I60838b067adb3586f2e5edca4092da1d3eab5731
Signed-off-by: Govind Singh <govinds@codeaurora.org>
Signed-off-by: Kalle Valo <kvalo@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/core.c | 16 +++++++++++++---
 drivers/net/wireless/ath/ath11k/core.h |  1 +
 drivers/net/wireless/ath/ath11k/pci.c  |  1 +
 3 files changed, 15 insertions(+), 3 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index 86027cd..afdc380 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -708,12 +708,11 @@ static void ath11k_core_restart(struct work_struct *work)
 	complete(&ab->driver_recovery);
 }
 
-int ath11k_core_init(struct ath11k_base *ab)
+static int ath11k_core_get_rproc_hdl (struct ath11k_base *ab)
 {
 	struct device *dev = ab->dev;
-	struct rproc *prproc;
 	phandle rproc_phandle;
-	int ret;
+	struct rproc *prproc;
 
 	if (of_property_read_u32(dev->of_node, "qcom,rproc", &rproc_phandle)) {
 		ath11k_err(ab, "failed to get q6_rproc handle\n");
@@ -725,9 +724,20 @@ int ath11k_core_init(struct ath11k_base *ab)
 		ath11k_err(ab, "failed to get rproc\n");
 		return -EINVAL;
 	}
+
 	ab->tgt_rproc = prproc;
 	ab->hw_params = ath11k_hw_params;
 
+	return 0;
+}
+
+int ath11k_core_init(struct ath11k_base *ab)
+{
+	int ret;
+
+	if (!ab->mhi_support)
+		ath11k_core_get_rproc_hdl(ab);
+
 	ret = ath11k_core_soc_create(ab);
 	if (ret) {
 		ath11k_err(ab, "failed to create soc core: %d\n", ret);
diff --git a/drivers/net/wireless/ath/ath11k/core.h b/drivers/net/wireless/ath/ath11k/core.h
index 7573029..3bd98e2 100644
--- a/drivers/net/wireless/ath/ath11k/core.h
+++ b/drivers/net/wireless/ath/ath11k/core.h
@@ -661,6 +661,7 @@ struct ath11k_base {
 	/* Round robbin based TCL ring selector */
 	atomic_t tcl_ring_selector;
 
+	bool mhi_support;
 	/* must be last */
 	u8 drv_priv[0] __aligned(sizeof(void *));
 };
diff --git a/drivers/net/wireless/ath/ath11k/pci.c b/drivers/net/wireless/ath/ath11k/pci.c
index 05accd7..f05db75 100644
--- a/drivers/net/wireless/ath/ath11k/pci.c
+++ b/drivers/net/wireless/ath/ath11k/pci.c
@@ -603,6 +603,7 @@ static int ath11k_pci_probe(struct pci_dev *pdev,
 	ab->hw_rev = hw_rev;
 	ab->hif.ops = &ath11k_pci_hif_ops;
 	pci_set_drvdata(pdev, ab);
+	ab->mhi_support = true;
 
 	ret = ath11k_pci_claim(ab_pci, pdev);
 	if (ret) {
-- 
2.7.4

